// -*- C++ -*- //

#ifndef MAP_SELECTOR_H
#define MAP_SELECTOR_H

class MapSelector;

#include "all_include.h"
#include "mapstorage.h"
#include "new_map_win.h"
#include "graph_displayer_canvas.h"
#include <libgnomecanvasmm.h>
#include <libgnomecanvasmm/polygon.h>

class MapSelector : public Gtk::HBox
{
protected:
  GraphDisplayerCanvas & gdc;
  ///The \ref MapStorage in which the visualizable maps are stored
  MapStorage & ms;
  NewMapWin & nmw;

  int id;

  bool itisedge;

  bool default_state;

  bool set_new_map;

  Gtk::ComboBoxText cbt;

  Gtk::Button * newbut, * defbut;

  Gtk::HBox hbox;

  Gtk::Label * label;

  Node node_to_update;
  Edge edge_to_update;


public:

  MapSelector(GraphDisplayerCanvas &, MapStorage &, NewMapWin &, int, bool);

  void update_list();

  ///If a radiobutton is clicked, this function determines
  ///which button was that and after that calls the
  ///appropriate function of the \ref GraphDisplayerCanvas
  ///to change the visible values of that attribute.
  virtual void comboChanged();

  virtual void new_but_pressed();

  virtual void reset();

  virtual void update(Node node);
  virtual void update(Edge edge);

  Glib::ustring get_active_text();
  void set_active_text(Glib::ustring);
  void append_text(Glib::ustring);
};

#endif
